/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of RC6.xs. Do not edit this file, edit RC6.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "RC6.xs"
/*
      author: John Hughes (jhughes@frostburg.edu)
    modified: 11/01

    I am indebted to Marc Lehmann, the author of the Crypt::Twofish2
    module, as I used his code as a guide.
*/

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "patchlevel.h"
#if (PATCHLEVEL == 4) || ((PATCHLEVEL == 5) && (SUBVERSION < 55))
static STRLEN nolen_na;
#define SvPV_nolen(sv) SvPV((sv), nolen_na)
#endif

#include "_rc6.c"

typedef struct rc6_stuff  /* This struct holds the key schedule. */
{
    unsigned int S[44];
}* Crypt__RC6;

#line 36 "RC6.c"

XS(XS_Crypt__RC6_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RC6_new)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::RC6::new(class, key)");
    {
	SV*	class = ST(0);
	SV*	key = ST(1);
	Crypt__RC6	RETVAL;
#line 44 "RC6.xs"
    {
        STRLEN keyLength;

        if (! SvPOK(key))
            croak("Error: key must be a string scalar!");

        keyLength = SvCUR(key);

        if (keyLength != 16 && keyLength != 24 && keyLength != 32)
            croak("Error: key must be 16, 24, or 32 bytes in length.");

        Newz(0, RETVAL, 1, struct rc6_stuff);

        rc6_generateKeySchedule(SvPV_nolen(key), keyLength, RETVAL->S);
    }         
#line 64 "RC6.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::RC6", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__RC6_encrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RC6_encrypt)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::RC6::encrypt(self, input)");
    {
	Crypt__RC6	self;
	SV*	input = ST(1);
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::RC6")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__RC6,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::RC6");
#line 68 "RC6.xs"
    {
        STRLEN blockSize;
        void* rawbytes = SvPV(input, blockSize);

        if (blockSize != 16)
        {
            croak("Error: block size must be 16 bytes.");
            RETVAL = newSVpv("", 0);
        }
        else
        {
            RETVAL = NEWSV(0, 16);
            SvPOK_only(RETVAL);
            SvCUR_set(RETVAL, 16);

            rc6_encrypt(rawbytes, self->S, SvPV_nolen(RETVAL));
        }
    }
#line 108 "RC6.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__RC6_decrypt); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RC6_decrypt)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::RC6::decrypt(self, input)");
    {
	Crypt__RC6	self;
	SV*	input = ST(1);
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::RC6")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__RC6,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::RC6");
#line 95 "RC6.xs"
    {
        STRLEN blockSize;
        void* rawbytes = SvPV(input, blockSize);

        if (blockSize != 16)
        {
            croak("Error: block size must be 16 bytes.");
            RETVAL = newSVpv("", 0);
        }
        else
        {
            RETVAL = NEWSV(0, 16);
            SvPOK_only(RETVAL);
            SvCUR_set(RETVAL, 16);

            rc6_decrypt(rawbytes, self->S, SvPV_nolen(RETVAL));
        }
    }
#line 152 "RC6.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__RC6_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__RC6_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::RC6::DESTROY(self)");
    {
	Crypt__RC6	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__RC6,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not a reference");
#line 121 "RC6.xs"
        Safefree(self);
#line 177 "RC6.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__RC6); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__RC6)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("Crypt::RC6::new", XS_Crypt__RC6_new, file, "$$");
        newXSproto("Crypt::RC6::encrypt", XS_Crypt__RC6_encrypt, file, "$$");
        newXSproto("Crypt::RC6::decrypt", XS_Crypt__RC6_decrypt, file, "$$");
        newXSproto("Crypt::RC6::DESTROY", XS_Crypt__RC6_DESTROY, file, "$");

    /* Initialisation Section */

#line 31 "RC6.xs"
{
	HV* stash = gv_stashpv("Crypt::RC6", 0);

	newCONSTSUB(stash, "keysize", newSViv(32));
	newCONSTSUB(stash, "blocksize", newSViv(16));
}

#line 208 "RC6.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

